<template>
    <el-container style="height: 100%">
        <el-header color="#333">
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                <el-table :data="sportOrderList" style="width: 100%">
                    <el-table-column type="expand">
                      <template slot-scope="props">
                        <el-card class="el-card">
                          <el-row :gutter="200" class="el-row"  type="flex"  v-for="item in props.row.serviceList" id=item :key="item.serviceId">
                              <el-col :lg="6" :xs="2" style="height: 10px">
                                <img :src="item.serviceImage" class="image" style="height: 200px;">
                              </el-col>
                              <el-col :lg="12" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="服务ID">
                                    <span>{{ item.serviceId }}</span>
                                  </el-form-item>
                                  <el-form-item label="健身房ID">
                                    <span>{{ item.serviceShopId }}</span>
                                  </el-form-item>
                                  <el-form-item label="服务名称">
                                    <span>{{ item.serviceName }}</span>
                                  </el-form-item>

                                  <!-- <el-form-item label="时长">
                                    <span>{{ item.serviceTime }}</span>
                                  </el-form-item> -->
                                  <el-form-item label="卡路里">
                                    <span>{{ item.serviceCalorie }}</span>
                                  </el-form-item>
                                  <el-form-item label="地址">
                                    <span>{{ item.serviceLocation }}</span>
                                  </el-form-item>

                                  <el-form-item label="服务时长:">
                                    <span >{{ item.serviceTime }}</span>
                                  </el-form-item>
                                  <el-form-item label="类别:">
                                    <span >{{ item.serviceCategory }}</span>
                                  </el-form-item>
                                  <el-form-item label="服务介绍:">
                                    <span >{{ item.serviceIntroduction }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                          </el-row>
                            <el-row :gutter="200" class="el-row"  type="flex">
                              <el-col :lg="20" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="评论:">
                                    <span ><br>{{ props.row.serviceOrderComment }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                            </el-row>
                          </el-card>
                      </template>
                    </el-table-column>
                    <el-table-column
                      label="订单号"
                      prop="serviceOrderId">
                    </el-table-column>
                    <el-table-column
                      label="订单商家"
                      prop="ShopName">
                    </el-table-column>
                    <el-table-column
                      label="开始时间"
                      prop="serviceOrderCreatedTimeFormatedStr">
                    </el-table-column>
                    <el-table-column
                      label="消耗热量"
                      prop="serviceOrderTotalCalorie">
                    </el-table-column>
                  <el-table-column
                    label="服务状态"
                    :filters="[{text: '已完成', value: 0 },{ text: '未完成', value: 1 }]"
                    :filter-method="filterStatusTag"
                    filter-placement="bottom-end">
                    <template slot-scope="scope">
                      <el-tag
                        :type="StatusType[scope.row.serviceOrderStatus]"
                        disable-transitions>{{StatusName[scope.row.serviceOrderStatus]}}</el-tag>
                    </template>
                  </el-table-column>
                  <el-table-column label="操作">
                    <template slot-scope="scope">
                      <el-button type="text" @click="MerOrder(scope.row.index)" size="small" v-if="scope.row.serviceOrderStatus === 0" :disabled = "disabled">接单</el-button>
                    </template>
                  </el-table-column>
                </el-table>
                <!-- <div style="width: 100%; text-align:center; margin-top: 20px;" v-if="islogin">
                  <el-button type="success" @click="openServiceRecommand()"><i class="el-icon-plus"></i>服务推荐</el-button>
                </div>
                <el-dialog title="订单推荐" :visible.sync="dialogTableVisible">
                  <el-table :data="RecFoodList" style="width: 100%">
                    <el-table-column type="expand">
                      <template slot-scope="props">
                        <el-card class="el-card">
                          <el-row :gutter="100" class="el-row"  type="flex">
                            <el-col :lg="8" :xs="24">
                              <img :src="props.row.serviceImage" class="image">
                            </el-col>
                            <el-col :lg="14" :xs="24" >
                              <el-form label-position="left" inline class="demo-table-expand">
                                <el-form-item label="服务ID">
                                  <span>{{ props.row.serviceId }}</span>
                                </el-form-item>
                                <el-form-item label="店铺ID">
                                  <span>{{ props.row.serviceShopId }}</span>
                                </el-form-item>
                                <el-form-item label="服务名称">
                                  <span>{{ props.row.serviceName }}</span>
                                </el-form-item>
                                <el-form-item label="卡路里">
                                  <span>{{ props.row.serviceCalorie }}</span>
                                </el-form-item>
                                <el-form-item label="位置">
                                  <span>{{ props.row.serviceLocation }}</span>
                                </el-form-item>
                                <el-form-item label="服务预约用时:">
                                  <span >{{ props.row.serviceTime }}</span>
                                </el-form-item>
                                <el-form-item label="类别:">
                                  <span >{{ props.row.serviceCategory }}</span>
                                </el-form-item>
                                <el-form-item label="服务介绍:">
                                  <span >{{ props.row.serviceIntroduction }}</span>
                                </el-form-item>
                              </el-form>
                            </el-col>
                          </el-row>
                        </el-card>
                      </template>
                    </el-table-column>
                    <el-table-column
                      label="服务名称"
                      prop="serviceName">
                    </el-table-column>
                    <el-table-column
                      label="服务类别"
                      prop="serviceCategory">
                    </el-table-column>
                    <el-table-column
                      label="服务时长"
                      prop="foodCnt">
                    </el-table-column>
                    <el-table-column
                      label="消耗卡路里"
                      prop="serviceCalorie">
                    </el-table-column>
                  </el-table>
                  <span style="width: 100%; text-align: right; font-size: 1.2em;">{{'总消耗热量:' + totalCalorie}}</span>
                  <div style="width: 100%; text-align:center;">
                    <el-button type="success" @click="ServiceRecommand()" :disabled = "recdisable">{{RecBtnStr}}</el-button>

                  </div>
                </el-dialog> -->
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import OrderManage from '@/services/browseservices'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import showViewInfoService from '@/services/showViewInfoService'
import BrowseServiceByShopID from '@/services/BrowseServiceByShopID'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'AdminRecognize',
  data () {
    return {
      activeName: 'rider',
      StatusType: [
        'info',
        'warning',
        'primary',
        'success'
      ],
      StatusName: [
        '未完成',
        '已完成'
      ],
      sportOrderList: [],
      user: {
      },
      shopInfo: {
      },
      isAdmin: false,
      isFoodMerchant: false,
      comment: '',
      hasFalse: false,
      disabled: false,
      dialogTableVisible: false,
      recdisable: false,
      timer: null,
      recommand: {
      },
      RecFoodList: [],
      RecFoodCnt: [],
      RecBtnStr: '重新推荐',
      cnt: 0,
      totalCalorie: 0,
      totalPrice: 0,
      islogin: false
    }
  },
  created () {
    this.islogin = this.$store.state.token !== ''
    if (this.$store.state.token !== '') {
      this.getOrderList()
    } else {
      this.$message({
        type: 'info',
        message: '您并无订单,无法查看'
      })
    }
  },
  methods: {
    async getOrderList () {
      try {
        var response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.user = response.data.data.user
        this.isAdmin = false
        for (var j in this.user.roles) {
          if (this.user.roles[j] === 'admin') {
            this.isAdmin = true
          }
        }
        console.log(this.$route.params.id)
        const responsef = await OrderManage.getservicelist(this.$route.params.id, {
          serviceOrderStatus: -1
        }, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.sportOrderList = responsef.data.data.serviceOrderList
        console.log(responsef)
        var i
        for (i = 0; i < this.sportOrderList.length; i++) {
          var responseShop = await BrowseServiceByShopID.getShopServiceList(this.sportOrderList[i].serviceOrderShopId, {
            headers: {'Authorization': this.$store.state.token}
          })
          this.sportOrderList[i].ShopName = responseShop.data.data.shopServices.shopName
          this.sportOrderList[i].index = i
        }
        this.$forceUpdate()
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
      }
    },
    openServiceRecommand () {
      this.ServiceRecommand()
      this.dialogTableVisible = true
    },
    async ServiceRecommand () {
      this.recdisable = true
      try {
        const response = await BrowseServiceByShopID.getRecommand({
          headers: {'Authorization': this.$store.state.token}
        })
        if (response.data.code === 400) {
          this.$message({
            type: 'info',
            message: response.data.msg
          })
        }
        this.recommand = response.data.data
        this.RecFoodList = response.data.data.services
        this.RecFoodCnt = response.data.data.time
        for (var i = 0; i < this.RecFoodList.length; i++) {
          this.RecFoodList[i].foodCnt = this.RecFoodCnt[i]
        }
        this.totalCalorie = this.recommand.calorie.toFixed(1)
        const TIME_COUNT = 5
        if (!this.timer) {
          this.cnt = TIME_COUNT
          this.timer = setInterval(() => {
            if (this.cnt > 0 && this.cnt <= TIME_COUNT) {
              this.cnt--
              this.RecBtnStr = '重新推荐(' + this.cnt + 'S)'
            } else {
              clearInterval(this.timer) // 清除定时器
              this.timer = null
              this.cnt = 0
              this.RecBtnStr = '重新推荐'
              this.recdisable = false
            }
          }, 1000)
        }
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
        this.recdisable = false
      }
    },
    MerOrder (index) {
      console.log(index)
      console.log(this.sportOrderList[index])
      if (this.sportOrderList[index].serviceOrderStatus === 1) {
        this.$message({
          showClose: true,
          message: '订单状态已完成，无法接单',
          type: 'error'
        })
        this.disabled = false
        return
      }
      this.$confirm('确认接单？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(async () => {
        var response = await OrderManage.MerOrder({
          serviceOrderId: this.sportOrderList[index].serviceOrderId,
          serviceOrderStatus: 1
        }, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log(response)
        this.getOrderList()
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消接单'
        })
      })
    },
    filterStatusTag (value, row) {
      console.log('val:' + value)
      return row.serviceOrderStatus === value
    }
  }
}

</script>

<style scoped>
  .demo-table-expand {
    font-size: 0;
  }
  .demo-table-expand label {
    width: 100%;
    color: #99a9bf;
  }
  .demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
    width: 50%;
  }
  .el-header {
      background-color: #333;
  }
  .el-main {
      padding-top: 0;
  }
  .el-row {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap;
  }
  .el-col {
  border-radius: 0px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 30px;
  }
</style>
